	
	include "P16F877.inc"	;include the defaults for the chip
	ERRORLEVEL	0,	-302	;suppress bank selection messages
	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_ON & _PWRTE_ON & _HS_OSC & _WRT_ENABLE_ON & _LVP_ON & _DEBUG_OFF & _CPD_OFF
	 list p=16f877
	

;Set the ports to be used
LCD_DATA        	EQU	PORTB           ; LCD data lines interface
LCD_CTRL        	EQU	PORTA           ; LCD control lines interface

DELAY           	EQU	0x023           ; Used in DELAYxxx routines
X_DELAY         	EQU	0x024           ; Used in X_DELAYxxx routines

; PORT control bits
EN           	EQU	1               ; LCD Enable control line
RS          	EQU	0               ; LCD Register-Select control line

;Set the variables to be used
Hundreds		equ 0x20
Tens			equ 0x21
units			equ	0x22
working			equ	0x23
numtocon		equ	0x24
count			equ	0x25	;used in looping routines
count1			equ	0x26	;used in delay routine
counta			equ	0x27	;used in delay routine
countb			equ	0x28	;used in delay routine
countdd			equ 0x29

	


;code for bootloader
	ORG 0x0000 ;reset vector 
;	clrf 0x3 ;zero status
;	movlw 0x00 ;high byte of long jump <<<these next 2 lines are important
;	movwf 0xA ;zero PCLATH
	goto start



;delay routine based on 4mhz clock
;500us

delay1sec
Delay500
	goto	$+1
	nop
	Movlw	D'164'	
	Movwf	Delay
delay500_loop
	Decfsz	Delay,f
	goto 	delay500_loop
	return

X_DELAY500		; delay of W x 500us
    MOVWF       X_DELAY            
X_DELAY500_LOOP
    CALL        DELAY500            
    DECFSZ      X_DELAY, F          
    GOTO        X_DELAY500_LOOP     
    RETURN   

Delay255
	movlw	0xff		;delay 255 mS
	goto	d0
Delay100
	movlw	d'99'		;delay 100mS
	goto	d0
Delay50
	movlw	d'50'		;delay 50mS
	goto	d0
Delay20
	movlw	d'20'		;delay 20mS
	goto	d0
Delay5
	movlw	0x05		;delay 5.000 ms (4 MHz clock)
d0	movwf	count1
d1	movlw	0xC7			;delay 1mS
	movwf	counta
	movlw	0x01
	movwf	countb
Delay_0
	decfsz	counta,f
	goto	$+2
	decfsz	countb,f
	goto	Delay_0
	decfsz	count1,f
	goto	d1
	retlw	0x00




;Set to 8bit mode
Bitmode8
	movlw	0x38
	call 	lcd_cmd
	movlw	0x06
	call 	lcd_cmd
	movlw	0x0d	
	call	lcd_cmd
	movlw	0x01
	call 	lcd_cmd
	movlw	0x02	
	call	lcd_cmd
	movlw	0x80
	call	lcd_cmd
	return
	


;send the command to the display
lcd_cmd
	bcf		lcd_ctrl,rs
	movwf	LCD_data
	bsf		lcd_ctrl,en
	nop
	bcf 	lcd_ctrl,en
	nop
	call 	delay5
	return

;send data to the display
lcd_char
	bsf		lcd_ctrl,rs
	movwf	LCD_data
	bsf		lcd_ctrl,en
	nop
	bcf 	lcd_ctrl,en
	call 	delay5
	return




Start
;Set port to be used as output
	bsf		status,5			;Switch to bank 1
	CLRF	LCD_Data
	CLRF	LCD_Ctrl
	movlw	0x06
	movwf	adcon1


	;setup prescaler
	bcf		option_reg,3
	bcf		option_reg,0
	bsf		option_reg,1	
	bsf		option_reg,2

	bcf		status,5	;Swicth to bank 0 





; wait for display to initialize
	call 	delay500

;set the display to use 8 bits for data transfer
	call 	bitmode8


;do 8 bit to bcd conversion
		clrf	Hundreds
		clrf	Tens
		clrf	Units


		movlw	d'159'				;load w with the number to convert
		movwf	numtocon		

		movlw	d'8'
		movwf	countdd		
ShiftLoop
;test lowerbcd		
		movfw	units
		andlw	b'1111'
		movwf	working
		movlw	d'5'
		subwf	working,0
		SKPC		
		Goto	TestUpperNibble
		movlw	d'3'
		addwf	units
TestUpperNibble		
		movfw	units
		andlw	b'11110000'
		movwf	working
		movlw	H'50'
		subwf	working,0
		SKPC		
		goto	Shiftbit
		movlw	H'30'
		addwf	units
shiftbit
		rlf		units,1
		rlf		hundreds,1
		SKPNC
		bsf		hundreds,0
		rlf		numtocon,1
		SKPNC	
		bsf		Units,0
		decfsz	countdd
		goto	ShiftLoop
		movfw	Units
		Movwf	Tens
		swapf	Tens,1
		movlw	b'1111'
		andwf	Units,1
		andwf	Tens,1
		movlw	d'48'
		addwf	Hundreds
		addwf	Tens
		addwf	Units

		movfw	hundreds	
		call 	lcd_char
	
		movfw	tens
		call 	lcd_char

		movfw	units
		call 	lcd_char


	
	goto 	$


	end